#!/usr/bin/perl

# we need the module configuration
do '../web-lib.pl';
&init_config();

# sub acl_security_form(acl)
# create output (which must fit into a 4-column table) an contains
# the needed input fields.
# paramter "acl" is a hash containing the values for current user

sub acl_security_form
{
    # the setting for this user are available here
    my $acl = $_[0];

    # FTP mode: just print a warning, that there is nothing to configure
    if ( $config{'mode'} ne "local" ) {
	print "<tr>\n";
	print " <td colspan=\"4\" align=\"center\">\n";
	print "  ACL support is only available for local mode. Sorry.<br>\n";
	print "  Go to the global "
	    . "<a href=\"/config.cgi?vacationadm\">module configuration</a> "
	    . "to change the mode.<br>\n";
	print " </td>\n";
	return;
    }

    # local mode: editing properties for which users should be possible
    print "<tr>\n";
    print " <td valign=\"top\">\n";
    print "  <b>Users, whos setting can be changed</b>\n";
    print " </td>\n";
    print " <td colspan=\"3\">\n";
    printf( "  <input type=\"radio\" name=\"editing\" value=\"all\" %s>All users<br>\n",
	    ( $acl->{'editing'} eq "all" ) ? "checked" : "" );

    printf( "  <input type=\"radio\" name=\"editing\" value=\"this\" %s>Only this user<br>\n",
	    ( $acl->{'editing'} eq "this" ) ? "checked" : "" );

    printf( "  <input type=\"radio\" name=\"editing\" value=\"listed\" %s>Only listed users<br>\n",
	    ( $acl->{'editing'} eq "listed" ) ? "checked" : "" );

    print "   <input type=\"text\" name=\"listed\" size=\"40\" value=\""
	. ( ( $acl->{'editing'} eq "listed" ) ? $acl->{'listed'} : "" )
	. "\">\n";
    print "   <input type=\"button\" onClick="
	. "'ifield = document.forms[0].users1;"
	. "chooser = window.open(\"/user_chooser.cgi?multi=1&user=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=500,height=200\");"
	. "chooser.ifield = ifield' value=\"...\">\n";
    print "   <br>\n";
    printf( "  <input type=\"radio\" name=\"editing\" value=\"except\" %s>All except listed users\n",
	    ( $acl->{'editing'} eq "except" ) ? "checked" : "" );
    print "   <input type=\"text\" name=\"except\" size=\"40\" value=\""
	. ( ( $acl->{'editing'} eq "except" ) ? $acl->{'except'} : "" )
	. "\">\n";
    print "   <input type=\"button\" onClick="
	. "'ifield = document.forms[0].users2;"
	. "chooser = window.open(\"/user_chooser.cgi?multi=1&user=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=500,height=200\");"
	. "chooser.ifield = ifield' value=\"...\">";
    print "   <br>\n";
    printf( "  <input type=\"radio\" name=\"editing\" value=\"range\" %s>Users with UID in range\n",
	    ( $acl->{'editing'} eq "range" ) ? "checked" : "" );
    print "  <input type=\"text\" name=\"low\" size=\"5\" value=\""
	. ( ( $acl->{'editing'} eq "range" ) ? $acl->{'lowbound'} : "" )
        . "\"> - \n";
    print "  <input type=\"text\" name=\"high\" size=\"5\" value=\""
	. ( ( $acl->{'editing'} eq "range" ) ? $acl->{'highbound'} : "" )
        . "\">\n";
    print " </td>\n";
    print "</tr>\n";
}


# sub acl_security_save(acl, input)
# this function is called from webmin to get the values which should be saved
# acl is a reference which must be filled by acl_security_save
# the values from the form are available in the input hash

sub acl_security_save
{
    $_[0]->{'editing'} = $in{'editing'};
    $_[0]->{'listed'} = $in{'listed'};
    $_[0]->{'except'} = $in{'except'};
    $_[0]->{'lowbound'} = $in{'low'};
    $_[0]->{'highbound'} = $in{'high'};
}
