#!/usr/bin/perl
###################################################################
# VacationAdm Webmin module                                       #
###################################################################
#                                                                 #
# $Id: index.cgi,v 1.2 2003/04/30 08:52:51 martin Exp $
#                                                                 #
###################################################################
#                                                                 #
# Module allows for admins and users to alter their .forward with #
# authentication through FTP, or local user/admin mode.           #
# This module is given freely, with no responsibility for its use #
# or upkeep to be placed on the author.                           #
# I am, of course interested in ideas on improving things         #
# so email: devil@medialab.at                                     #
#                                                                 #
###################################################################
#                                                                 #
# index.cgi                                                       #
#    This presents the user with a simple form for allowing users #
#    to enter there forward message, whether the forwarding is    #
#    ON or OFF, forwarding to another E-Mail address or pager     #
#    and lastly their username and password of FTP in user mode   #
#    Authenication occurring in the next script, vacation.cgi     #
#                                                                 #
###################################################################

# get some configuration options
do '../web-lib.pl';
&init_config();

# force a fflush after each print/write command
$|=1;

# The width of the first column
$width=150;


&header($text{'index_title'}, "", undef, 1, 1, undef,
        "Written by <a href=http://devil.medialab.at>Devil<br></a>" .
	"Enhanced by <a href=\"http://stud3.tuwien.ac.at/~e9926483\">Martin H&ouml;ller</a><br>" .
	"Version 1.1.2");

print "<HR>\n\n";

# Check for configuration errors:
if ( $config{'mode'} eq "ftp" &&
     $config{'server_domain'} eq "" ) {
  print $text{'index_error_undef_config1'};
  &footer("../", "Webmin");
  exit;
}
elsif ( $config{'vacation_path'} eq "" ) {
  print $text{'index_error_undef_config2'};
  &footer("../", "Webmin");
  exit;
}


#
# Seems there are no errors, let's go on...
#

print '<FORM METHOD="POST" ACTION="vacation.cgi">',"\n\n";

# Open the table
print '<table border="0" width="100%">',"\n";

# The Auto-Reply Header
print "  <tr>\n";
print "    <th align=\"center\" width=\"100%\" colspan=\"2\" $tb>\n";
print "      <h2>Auto-Reply</h2>\n";
print "    </th>\n";
print "  <tr><td>&nbsp;</td></tr>";

# The user authentication (just needed if modifying other users is allowed)
my %access = &get_module_acl();
if ( $access{'editing'} ne "this" ) {
    print "  <tr>\n";
    print "    <th align=\"left\" width=\"$width\">\n";
    print "      $text{'index_login_info'}\n";
    print "    </th>\n";
    print "    <th $tb>\n";
    print "      <center>\n";
    if ( $config{'mode'} ne "ftp" ) {
	print "        $text{'index_login_admin_title'}\n";
    }
    else {
	print "        $text{'index_login_title'}\n";
    }
    print "      </center>\n";
    print "    </th>\n";
    print "  </tr>\n";
    print "  <tr>\n";
    print "    <td></td>\n";
    print "    <td $cb>\n";
    print '      <center><table width="100%" border="0">',"\n";
    print "        <tr>\n";
    print "          <td ",' align="right">',"\n";
    print "            $text{'index_login_name'}\n";
    print "          </td>\n";
    print "          <td $cb>\n";
    print '            <INPUT TYPE=TEXT   NAME="user" SIZE=9 MAXLENGTH=256>',"\n";
    print "          </td>\n";
    print "        </tr>\n";
# we don't need a password in admin mode
    if ($config{'mode'} eq "ftp") {
	print "        <tr>\n";
	print "          <td",' align="right">',"\n";
	print "            $text{'index_login_password'}\n";
	print "          </td>\n";
	print "          <td $cb>\n";
	print '            <INPUT TYPE=PASSWORD   NAME="pass" SIZE=9 MAXLENGTH=256>',"\n";
	print "          </td>\n";
	print "        </tr>\n";
    }
    print "      </table></center>\n";
    print "    </td>\n";
    print "  </tr>\n";
}

# The on/off radio button
print "  <tr>\n";
print "    <th align=\"left\" width=\"$width\">\n";
print "      $text{'index_activate_info'}\n";
print "    </th>\n";
print "    <th $tb>","\n";
print "      <center>\n";
print "        $text{'index_activate_title'}\n";
print "      </center>\n";
print "    </th>\n";
print "  </tr>\n";
print "  <tr>\n";
print "    <td border=0></td>\n";
print "    <td $cb>\n";
print "      <table width=\"100%\">\n";
print "        <tr>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="activate" VALUE="set" checked>';
print "              $text{'index_activate_seton'}\n";
print "            </center>\n";
print "          </td>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="activate" VALUE="unset">';
print "              $text{'index_activate_setoff'}\n";
print "            </center>\n";
print "          </td>\n";
print "        <tr>\n";
print "      </table>\n";
print "    </td>\n";
print "  </tr>\n";


# The message for vacation
print "  <tr>\n";
print "    <th align=\"left\" width=\"$width\">\n";
print "      $text{'index_msg_info'}\n";
print "    </th>\n";
print "    <th $tb>\n";
print "      <center>\n";
print "        $text{'index_msg_title'}\n";
print "      </center>\n";
print "    </th>\n";
print "  </tr>\n";
print "  <tr>\n";
print "    <td></td>\n";
print "    <td $cb>\n";
print "      <center>\n";
print "        <TEXTAREA NAME=\"mess\" ROWS=\"8\" COLS=\"60\">\n";
print "$text{'index_msg_default0'}\n\n";
print "$text{'index_msg_default1'}\n";
print "$text{'index_msg_default2'}";
print         "</TEXTAREA>\n";
print "      </center>\n";
print "     </td>\n";
print "   </tr>\n";


# Hold Mail
print "  <tr>\n";
print "    <th align=\"left\" width=\"$width\">\n";
print "      $text{'index_hold_info'}\n";
print "    </th>\n";
print "    <th $tb>","\n";
print "      <center>\n";
print "        $text{'index_hold_title'}\n";
print "      </center>\n";
print "    </th>\n";
print "  </tr>\n";
print "  <tr>\n";
print "    <td border=0></td>\n";
print "    <td $cb>\n";
print "      <table width=\"100%\">\n";
print "        <tr>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="hold" VALUE="yes" checked>';
print "              $text{'index_hold_seton'}\n";
print "            </center>\n";
print "          </td>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="hold" VALUE="no">';
print "              $text{'index_hold_setoff'}\n";
print "            </center>\n";
print "          </td>\n";
print "        <tr>\n";
print "      </table>\n";
print "    </td>\n";
print "  </tr>\n";


# a blank table row
print "  <tr><td>&nbsp;</td></tr>\n";


# The Mail-Forwarding Header
print "  <tr>\n";
print "    <th align=\"center\" width=\"100%\" colspan=\"2\" $tb>\n";
print "      <h2>Mail Forwarding</h2>\n";
print "    </th>\n";
print "  <tr><td>&nbsp;</td></tr>";

# The yes/no radio button
print "  <tr>\n";
print "    <th align=\"left\" width=\"$width\">\n";
print "      $text{'index_activate_fwd_info'}\n";
print "    </th>\n";
print "    <th $tb>","\n";
print "      <center>\n";
print "        $text{'index_activate_fwd_title'}\n";
print "      </center>\n";
print "    </th>\n";
print "  </tr>\n";
print "  <tr>\n";
print "    <td border=0></td>\n";
print "    <td $cb>\n";
print "      <table width=\"100%\">\n";
print "        <tr>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="activate_fwd" VALUE="set">';
print "              $text{'index_activate_fwd_yes'}\n";
print "            </center>\n";
print "          </td>\n";
print "          <td>\n";
print "            <center>\n";
print '              <INPUT TYPE="radio" NAME="activate_fwd" VALUE="unset" checked>';
print "              $text{'index_activate_fwd_no'}\n";
print "            </center>\n";
print "          </td>\n";
print "        <tr>\n";
print "      </table>\n";
print "    </td>\n";
print "  </tr>\n";

# Optional Forwarding
print "  <tr>\n";
print "    <th align=\"left\" width=\"$width\">\n";
print "      $text{'index_forward_info'}\n";
print "    </th>\n";
print "    <th $tb>\n";
print "      <center>\n";
print "        $text{'index_forward_title'}\n";
print "      </center>\n";
print "    </th>\n";
print "   </tr>\n";
print "  <tr>\n";
print "    <td></td>\n";
print "    <td $cb>\n";
print "      <center>\n";
print '        <TEXTAREA NAME="fwrd" ROWS="3" COLS="50">';
print            "<$text{'index_forward_msg'}>";
print         "</TEXTAREA>\n";
print "      </center>\n";
print "     </td>\n";
print "   </tr>\n";


# a blank table row
print "  <tr><td>&nbsp;</td></tr>\n";


# The submit button
print "        <tr $cb>\n";
print "          <td colspan=\"2\">\n";
print '            <center><INPUT TYPE="submit" VALUE="';
print              "$text{'index_apply'}\"></center>\n";
print "          </td>\n";
print "        </tr>\n";


# Close the table...
print "</table>\n\n";

# ...and the HTML file
print "</FORM>\n";
print "<HR>\n";

&footer("../", "Webmin");
